// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/cisco-open/kubei/api/client/models"
)

// PostApplicationsReader is a Reader for the PostApplications structure.
type PostApplicationsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostApplicationsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewPostApplicationsCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 409:
		result := NewPostApplicationsConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPostApplicationsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPostApplicationsCreated creates a PostApplicationsCreated with default headers values
func NewPostApplicationsCreated() *PostApplicationsCreated {
	return &PostApplicationsCreated{}
}

/* PostApplicationsCreated describes a response with status code 201, with default header values.

New application was created.
*/
type PostApplicationsCreated struct {
	Payload *models.ApplicationInfo
}

func (o *PostApplicationsCreated) Error() string {
	return fmt.Sprintf("[POST /applications][%d] postApplicationsCreated  %+v", 201, o.Payload)
}
func (o *PostApplicationsCreated) GetPayload() *models.ApplicationInfo {
	return o.Payload
}

func (o *PostApplicationsCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ApplicationInfo)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostApplicationsConflict creates a PostApplicationsConflict with default headers values
func NewPostApplicationsConflict() *PostApplicationsConflict {
	return &PostApplicationsConflict{}
}

/* PostApplicationsConflict describes a response with status code 409, with default header values.

Application already exist.
*/
type PostApplicationsConflict struct {
	Payload *models.ApplicationInfo
}

func (o *PostApplicationsConflict) Error() string {
	return fmt.Sprintf("[POST /applications][%d] postApplicationsConflict  %+v", 409, o.Payload)
}
func (o *PostApplicationsConflict) GetPayload() *models.ApplicationInfo {
	return o.Payload
}

func (o *PostApplicationsConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ApplicationInfo)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostApplicationsDefault creates a PostApplicationsDefault with default headers values
func NewPostApplicationsDefault(code int) *PostApplicationsDefault {
	return &PostApplicationsDefault{
		_statusCode: code,
	}
}

/* PostApplicationsDefault describes a response with status code -1, with default header values.

unknown error
*/
type PostApplicationsDefault struct {
	_statusCode int

	Payload *models.APIResponse
}

// Code gets the status code for the post applications default response
func (o *PostApplicationsDefault) Code() int {
	return o._statusCode
}

func (o *PostApplicationsDefault) Error() string {
	return fmt.Sprintf("[POST /applications][%d] PostApplications default  %+v", o._statusCode, o.Payload)
}
func (o *PostApplicationsDefault) GetPayload() *models.APIResponse {
	return o.Payload
}

func (o *PostApplicationsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APIResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
