// Code generated by go-swagger; DO NOT EDIT.

package restapi

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
)

var (
	// SwaggerJSON embedded version of the swagger document used at generation time
	SwaggerJSON json.RawMessage
	// FlatSwaggerJSON embedded flattened version of the swagger document used at generation time
	FlatSwaggerJSON json.RawMessage
)

func init() {
	SwaggerJSON = json.RawMessage([]byte(`{
  "consumes": [
    "application/json"
  ],
  "produces": [
    "application/json"
  ],
  "schemes": [
    "http"
  ],
  "swagger": "2.0",
  "info": {
    "title": "KubeClarity Runtime Scan APIs",
    "version": "1.0.0"
  },
  "basePath": "/api",
  "paths": {
    "/scan/{scan-uuid}/cisDockerBenchmark/results": {
      "post": {
        "summary": "Report an image CIS docker benchmark scan for a specific scan UUID.",
        "parameters": [
          {
            "type": "string",
            "format": "uuid",
            "name": "scan-uuid",
            "in": "path",
            "required": true
          },
          {
            "name": "body",
            "in": "body",
            "required": true,
            "schema": {
              "$ref": "#/definitions/CISDockerBenchmarkScan"
            }
          }
        ],
        "responses": {
          "201": {
            "description": "CIS docker benchmark scan successfully reported."
          },
          "default": {
            "$ref": "#/responses/UnknownError"
          }
        }
      }
    },
    "/scan/{scan-uuid}/contentAnalysis": {
      "post": {
        "summary": "Report a content analysis for a specific resource",
        "parameters": [
          {
            "type": "string",
            "format": "uuid",
            "name": "scan-uuid",
            "in": "path",
            "required": true
          },
          {
            "name": "body",
            "in": "body",
            "required": true,
            "schema": {
              "$ref": "#/definitions/ImageContentAnalysis"
            }
          }
        ],
        "responses": {
          "201": {
            "description": "Image content analysis successfully reported."
          },
          "default": {
            "$ref": "#/responses/UnknownError"
          }
        }
      }
    },
    "/scan/{scan-uuid}/results": {
      "post": {
        "summary": "Report an image vulnerability scan for a specific scan UUID.",
        "parameters": [
          {
            "type": "string",
            "format": "uuid",
            "name": "scan-uuid",
            "in": "path",
            "required": true
          },
          {
            "name": "body",
            "in": "body",
            "required": true,
            "schema": {
              "$ref": "#/definitions/ImageVulnerabilityScan"
            }
          }
        ],
        "responses": {
          "201": {
            "description": "Image vulnerability scan successfully reported."
          },
          "default": {
            "$ref": "#/responses/UnknownError"
          }
        }
      }
    }
  },
  "definitions": {
    "ApiResponse": {
      "description": "An object that is returned in all cases of failures.",
      "type": "object",
      "properties": {
        "message": {
          "type": "string"
        }
      }
    },
    "AttackComplexity": {
      "type": "string",
      "enum": [
        "LOW",
        "HIGH"
      ]
    },
    "AttackVector": {
      "type": "string",
      "enum": [
        "NETWORK",
        "ADJACENT",
        "LOCAL",
        "PHYSICAL"
      ]
    },
    "Availability": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "CISDockerBenchmarkAssessment": {
      "type": "object",
      "properties": {
        "code": {
          "type": "string"
        },
        "desc": {
          "type": "string"
        },
        "filename": {
          "type": "string"
        },
        "level": {
          "type": "number",
          "format": "integer"
        }
      }
    },
    "CISDockerBenchmarkCodeInfo": {
      "type": "object",
      "properties": {
        "assessments": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/CISDockerBenchmarkAssessment"
          }
        },
        "code": {
          "type": "string"
        },
        "level": {
          "type": "number",
          "format": "integer"
        }
      }
    },
    "CISDockerBenchmarkScan": {
      "type": "object",
      "properties": {
        "cisDockerBenchmarkScanResult": {
          "$ref": "#/definitions/CISDockerBenchmarkScanResult"
        },
        "imageID": {
          "type": "string"
        }
      }
    },
    "CISDockerBenchmarkScanResult": {
      "type": "object",
      "properties": {
        "error": {
          "$ref": "#/definitions/ScanError"
        },
        "result": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/CISDockerBenchmarkCodeInfo"
          }
        },
        "status": {
          "$ref": "#/definitions/ScanStatus"
        }
      }
    },
    "CVSS": {
      "type": "object",
      "properties": {
        "cvssV3Metrics": {
          "$ref": "#/definitions/CVSSV3Metrics"
        },
        "cvssV3Vector": {
          "$ref": "#/definitions/CVSSV3Vector"
        }
      }
    },
    "CVSSV3Metrics": {
      "type": "object",
      "properties": {
        "baseScore": {
          "type": "number"
        },
        "exploitabilityScore": {
          "type": "number"
        },
        "impactScore": {
          "type": "number"
        }
      }
    },
    "CVSSV3Vector": {
      "type": "object",
      "properties": {
        "attackComplexity": {
          "$ref": "#/definitions/AttackComplexity"
        },
        "attackVector": {
          "$ref": "#/definitions/AttackVector"
        },
        "availability": {
          "$ref": "#/definitions/Availability"
        },
        "confidentiality": {
          "$ref": "#/definitions/Confidentiality"
        },
        "integrity": {
          "$ref": "#/definitions/Integrity"
        },
        "privilegesRequired": {
          "$ref": "#/definitions/PrivilegesRequired"
        },
        "scope": {
          "$ref": "#/definitions/Scope"
        },
        "userInteraction": {
          "$ref": "#/definitions/UserInteraction"
        },
        "vector": {
          "type": "string"
        }
      }
    },
    "Confidentiality": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "ErrorType": {
      "type": "string",
      "enum": [
        "TBD"
      ]
    },
    "ImageContentAnalysis": {
      "type": "object",
      "properties": {
        "imageID": {
          "type": "string"
        },
        "resourceContentAnalysis": {
          "$ref": "#/definitions/ResourceContentAnalysis"
        }
      }
    },
    "ImageVulnerabilityScan": {
      "type": "object",
      "properties": {
        "imageID": {
          "type": "string"
        },
        "resourceVulnerabilityScan": {
          "$ref": "#/definitions/ResourceVulnerabilityScan"
        }
      }
    },
    "Integrity": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "PackageContentAnalysis": {
      "type": "object",
      "properties": {
        "analyzers": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "package": {
          "$ref": "#/definitions/PackageInfo"
        }
      }
    },
    "PackageInfo": {
      "type": "object",
      "properties": {
        "language": {
          "type": "string"
        },
        "license": {
          "type": "string"
        },
        "name": {
          "type": "string"
        },
        "version": {
          "type": "string"
        }
      }
    },
    "PackageVulnerabilityScan": {
      "type": "object",
      "properties": {
        "cvss": {
          "$ref": "#/definitions/CVSS"
        },
        "description": {
          "type": "string"
        },
        "fixVersion": {
          "type": "string"
        },
        "links": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "package": {
          "$ref": "#/definitions/PackageInfo"
        },
        "scanners": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "severity": {
          "$ref": "#/definitions/VulnerabilitySeverity"
        },
        "vulnerabilityName": {
          "type": "string"
        }
      }
    },
    "PrivilegesRequired": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "ResourceContentAnalysis": {
      "type": "object",
      "properties": {
        "packages": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/PackageContentAnalysis"
          }
        },
        "resource": {
          "$ref": "#/definitions/ResourceInfo"
        }
      }
    },
    "ResourceInfo": {
      "type": "object",
      "properties": {
        "resourceHash": {
          "type": "string"
        },
        "resourceName": {
          "type": "string"
        },
        "resourceType": {
          "$ref": "#/definitions/ResourceType"
        }
      }
    },
    "ResourceLayerCommand": {
      "description": "Container image layer with command.",
      "type": "object",
      "properties": {
        "command": {
          "type": "string"
        },
        "layer": {
          "type": "string"
        }
      }
    },
    "ResourceType": {
      "type": "string",
      "enum": [
        "IMAGE",
        "DIRECTORY",
        "FILE"
      ]
    },
    "ResourceVulnerabilityScan": {
      "type": "object",
      "properties": {
        "error": {
          "$ref": "#/definitions/ScanError"
        },
        "packageVulnerabilities": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/PackageVulnerabilityScan"
          }
        },
        "resource": {
          "$ref": "#/definitions/ResourceInfo"
        },
        "resourceLayerCommands": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/ResourceLayerCommand"
          }
        },
        "status": {
          "$ref": "#/definitions/ScanStatus"
        }
      }
    },
    "ScanError": {
      "type": "object",
      "properties": {
        "message": {
          "type": "string"
        },
        "type": {
          "$ref": "#/definitions/ErrorType"
        }
      }
    },
    "ScanStatus": {
      "type": "string",
      "enum": [
        "SUCCESS",
        "FAILED"
      ]
    },
    "Scope": {
      "type": "string",
      "enum": [
        "UNCHANGED",
        "CHANGED"
      ]
    },
    "SuccessResponse": {
      "description": "An object that is returned in cases of success that returns nothing.",
      "type": "object",
      "properties": {
        "message": {
          "type": "string"
        }
      }
    },
    "UserInteraction": {
      "type": "string",
      "enum": [
        "NONE",
        "REQUIRED"
      ]
    },
    "VulnerabilitySeverity": {
      "type": "string",
      "enum": [
        "CRITICAL",
        "HIGH",
        "MEDIUM",
        "LOW",
        "NEGLIGIBLE"
      ]
    }
  },
  "responses": {
    "Success": {
      "description": "success message",
      "schema": {
        "$ref": "#/definitions/SuccessResponse"
      }
    },
    "UnknownError": {
      "description": "unknown error",
      "schema": {
        "$ref": "#/definitions/ApiResponse"
      }
    }
  }
}`))
	FlatSwaggerJSON = json.RawMessage([]byte(`{
  "consumes": [
    "application/json"
  ],
  "produces": [
    "application/json"
  ],
  "schemes": [
    "http"
  ],
  "swagger": "2.0",
  "info": {
    "title": "KubeClarity Runtime Scan APIs",
    "version": "1.0.0"
  },
  "basePath": "/api",
  "paths": {
    "/scan/{scan-uuid}/cisDockerBenchmark/results": {
      "post": {
        "summary": "Report an image CIS docker benchmark scan for a specific scan UUID.",
        "parameters": [
          {
            "type": "string",
            "format": "uuid",
            "name": "scan-uuid",
            "in": "path",
            "required": true
          },
          {
            "name": "body",
            "in": "body",
            "required": true,
            "schema": {
              "$ref": "#/definitions/CISDockerBenchmarkScan"
            }
          }
        ],
        "responses": {
          "201": {
            "description": "CIS docker benchmark scan successfully reported."
          },
          "default": {
            "description": "unknown error",
            "schema": {
              "$ref": "#/definitions/ApiResponse"
            }
          }
        }
      }
    },
    "/scan/{scan-uuid}/contentAnalysis": {
      "post": {
        "summary": "Report a content analysis for a specific resource",
        "parameters": [
          {
            "type": "string",
            "format": "uuid",
            "name": "scan-uuid",
            "in": "path",
            "required": true
          },
          {
            "name": "body",
            "in": "body",
            "required": true,
            "schema": {
              "$ref": "#/definitions/ImageContentAnalysis"
            }
          }
        ],
        "responses": {
          "201": {
            "description": "Image content analysis successfully reported."
          },
          "default": {
            "description": "unknown error",
            "schema": {
              "$ref": "#/definitions/ApiResponse"
            }
          }
        }
      }
    },
    "/scan/{scan-uuid}/results": {
      "post": {
        "summary": "Report an image vulnerability scan for a specific scan UUID.",
        "parameters": [
          {
            "type": "string",
            "format": "uuid",
            "name": "scan-uuid",
            "in": "path",
            "required": true
          },
          {
            "name": "body",
            "in": "body",
            "required": true,
            "schema": {
              "$ref": "#/definitions/ImageVulnerabilityScan"
            }
          }
        ],
        "responses": {
          "201": {
            "description": "Image vulnerability scan successfully reported."
          },
          "default": {
            "description": "unknown error",
            "schema": {
              "$ref": "#/definitions/ApiResponse"
            }
          }
        }
      }
    }
  },
  "definitions": {
    "ApiResponse": {
      "description": "An object that is returned in all cases of failures.",
      "type": "object",
      "properties": {
        "message": {
          "type": "string"
        }
      }
    },
    "AttackComplexity": {
      "type": "string",
      "enum": [
        "LOW",
        "HIGH"
      ]
    },
    "AttackVector": {
      "type": "string",
      "enum": [
        "NETWORK",
        "ADJACENT",
        "LOCAL",
        "PHYSICAL"
      ]
    },
    "Availability": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "CISDockerBenchmarkAssessment": {
      "type": "object",
      "properties": {
        "code": {
          "type": "string"
        },
        "desc": {
          "type": "string"
        },
        "filename": {
          "type": "string"
        },
        "level": {
          "type": "number",
          "format": "integer"
        }
      }
    },
    "CISDockerBenchmarkCodeInfo": {
      "type": "object",
      "properties": {
        "assessments": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/CISDockerBenchmarkAssessment"
          }
        },
        "code": {
          "type": "string"
        },
        "level": {
          "type": "number",
          "format": "integer"
        }
      }
    },
    "CISDockerBenchmarkScan": {
      "type": "object",
      "properties": {
        "cisDockerBenchmarkScanResult": {
          "$ref": "#/definitions/CISDockerBenchmarkScanResult"
        },
        "imageID": {
          "type": "string"
        }
      }
    },
    "CISDockerBenchmarkScanResult": {
      "type": "object",
      "properties": {
        "error": {
          "$ref": "#/definitions/ScanError"
        },
        "result": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/CISDockerBenchmarkCodeInfo"
          }
        },
        "status": {
          "$ref": "#/definitions/ScanStatus"
        }
      }
    },
    "CVSS": {
      "type": "object",
      "properties": {
        "cvssV3Metrics": {
          "$ref": "#/definitions/CVSSV3Metrics"
        },
        "cvssV3Vector": {
          "$ref": "#/definitions/CVSSV3Vector"
        }
      }
    },
    "CVSSV3Metrics": {
      "type": "object",
      "properties": {
        "baseScore": {
          "type": "number"
        },
        "exploitabilityScore": {
          "type": "number"
        },
        "impactScore": {
          "type": "number"
        }
      }
    },
    "CVSSV3Vector": {
      "type": "object",
      "properties": {
        "attackComplexity": {
          "$ref": "#/definitions/AttackComplexity"
        },
        "attackVector": {
          "$ref": "#/definitions/AttackVector"
        },
        "availability": {
          "$ref": "#/definitions/Availability"
        },
        "confidentiality": {
          "$ref": "#/definitions/Confidentiality"
        },
        "integrity": {
          "$ref": "#/definitions/Integrity"
        },
        "privilegesRequired": {
          "$ref": "#/definitions/PrivilegesRequired"
        },
        "scope": {
          "$ref": "#/definitions/Scope"
        },
        "userInteraction": {
          "$ref": "#/definitions/UserInteraction"
        },
        "vector": {
          "type": "string"
        }
      }
    },
    "Confidentiality": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "ErrorType": {
      "type": "string",
      "enum": [
        "TBD"
      ]
    },
    "ImageContentAnalysis": {
      "type": "object",
      "properties": {
        "imageID": {
          "type": "string"
        },
        "resourceContentAnalysis": {
          "$ref": "#/definitions/ResourceContentAnalysis"
        }
      }
    },
    "ImageVulnerabilityScan": {
      "type": "object",
      "properties": {
        "imageID": {
          "type": "string"
        },
        "resourceVulnerabilityScan": {
          "$ref": "#/definitions/ResourceVulnerabilityScan"
        }
      }
    },
    "Integrity": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "PackageContentAnalysis": {
      "type": "object",
      "properties": {
        "analyzers": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "package": {
          "$ref": "#/definitions/PackageInfo"
        }
      }
    },
    "PackageInfo": {
      "type": "object",
      "properties": {
        "language": {
          "type": "string"
        },
        "license": {
          "type": "string"
        },
        "name": {
          "type": "string"
        },
        "version": {
          "type": "string"
        }
      }
    },
    "PackageVulnerabilityScan": {
      "type": "object",
      "properties": {
        "cvss": {
          "$ref": "#/definitions/CVSS"
        },
        "description": {
          "type": "string"
        },
        "fixVersion": {
          "type": "string"
        },
        "links": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "package": {
          "$ref": "#/definitions/PackageInfo"
        },
        "scanners": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "severity": {
          "$ref": "#/definitions/VulnerabilitySeverity"
        },
        "vulnerabilityName": {
          "type": "string"
        }
      }
    },
    "PrivilegesRequired": {
      "type": "string",
      "enum": [
        "NONE",
        "LOW",
        "HIGH"
      ]
    },
    "ResourceContentAnalysis": {
      "type": "object",
      "properties": {
        "packages": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/PackageContentAnalysis"
          }
        },
        "resource": {
          "$ref": "#/definitions/ResourceInfo"
        }
      }
    },
    "ResourceInfo": {
      "type": "object",
      "properties": {
        "resourceHash": {
          "type": "string"
        },
        "resourceName": {
          "type": "string"
        },
        "resourceType": {
          "$ref": "#/definitions/ResourceType"
        }
      }
    },
    "ResourceLayerCommand": {
      "description": "Container image layer with command.",
      "type": "object",
      "properties": {
        "command": {
          "type": "string"
        },
        "layer": {
          "type": "string"
        }
      }
    },
    "ResourceType": {
      "type": "string",
      "enum": [
        "IMAGE",
        "DIRECTORY",
        "FILE"
      ]
    },
    "ResourceVulnerabilityScan": {
      "type": "object",
      "properties": {
        "error": {
          "$ref": "#/definitions/ScanError"
        },
        "packageVulnerabilities": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/PackageVulnerabilityScan"
          }
        },
        "resource": {
          "$ref": "#/definitions/ResourceInfo"
        },
        "resourceLayerCommands": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/ResourceLayerCommand"
          }
        },
        "status": {
          "$ref": "#/definitions/ScanStatus"
        }
      }
    },
    "ScanError": {
      "type": "object",
      "properties": {
        "message": {
          "type": "string"
        },
        "type": {
          "$ref": "#/definitions/ErrorType"
        }
      }
    },
    "ScanStatus": {
      "type": "string",
      "enum": [
        "SUCCESS",
        "FAILED"
      ]
    },
    "Scope": {
      "type": "string",
      "enum": [
        "UNCHANGED",
        "CHANGED"
      ]
    },
    "SuccessResponse": {
      "description": "An object that is returned in cases of success that returns nothing.",
      "type": "object",
      "properties": {
        "message": {
          "type": "string"
        }
      }
    },
    "UserInteraction": {
      "type": "string",
      "enum": [
        "NONE",
        "REQUIRED"
      ]
    },
    "VulnerabilitySeverity": {
      "type": "string",
      "enum": [
        "CRITICAL",
        "HIGH",
        "MEDIUM",
        "LOW",
        "NEGLIGIBLE"
      ]
    }
  },
  "responses": {
    "Success": {
      "description": "success message",
      "schema": {
        "$ref": "#/definitions/SuccessResponse"
      }
    },
    "UnknownError": {
      "description": "unknown error",
      "schema": {
        "$ref": "#/definitions/ApiResponse"
      }
    }
  }
}`))
}
