// Code generated by go-swagger; DO NOT EDIT.

package vulnerability

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetVulnerabilitiesByProjectParams creates a new GetVulnerabilitiesByProjectParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetVulnerabilitiesByProjectParams() *GetVulnerabilitiesByProjectParams {
	return &GetVulnerabilitiesByProjectParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetVulnerabilitiesByProjectParamsWithTimeout creates a new GetVulnerabilitiesByProjectParams object
// with the ability to set a timeout on a request.
func NewGetVulnerabilitiesByProjectParamsWithTimeout(timeout time.Duration) *GetVulnerabilitiesByProjectParams {
	return &GetVulnerabilitiesByProjectParams{
		timeout: timeout,
	}
}

// NewGetVulnerabilitiesByProjectParamsWithContext creates a new GetVulnerabilitiesByProjectParams object
// with the ability to set a context for a request.
func NewGetVulnerabilitiesByProjectParamsWithContext(ctx context.Context) *GetVulnerabilitiesByProjectParams {
	return &GetVulnerabilitiesByProjectParams{
		Context: ctx,
	}
}

// NewGetVulnerabilitiesByProjectParamsWithHTTPClient creates a new GetVulnerabilitiesByProjectParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetVulnerabilitiesByProjectParamsWithHTTPClient(client *http.Client) *GetVulnerabilitiesByProjectParams {
	return &GetVulnerabilitiesByProjectParams{
		HTTPClient: client,
	}
}

/* GetVulnerabilitiesByProjectParams contains all the parameters to send to the API endpoint
   for the get vulnerabilities by project operation.

   Typically these are written to a http.Request.
*/
type GetVulnerabilitiesByProjectParams struct {

	/* Suppressed.

	   Optionally includes suppressed vulnerabilities
	*/
	Suppressed *bool

	// UUID.
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get vulnerabilities by project params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetVulnerabilitiesByProjectParams) WithDefaults() *GetVulnerabilitiesByProjectParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get vulnerabilities by project params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetVulnerabilitiesByProjectParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) WithTimeout(timeout time.Duration) *GetVulnerabilitiesByProjectParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) WithContext(ctx context.Context) *GetVulnerabilitiesByProjectParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) WithHTTPClient(client *http.Client) *GetVulnerabilitiesByProjectParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithSuppressed adds the suppressed to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) WithSuppressed(suppressed *bool) *GetVulnerabilitiesByProjectParams {
	o.SetSuppressed(suppressed)
	return o
}

// SetSuppressed adds the suppressed to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) SetSuppressed(suppressed *bool) {
	o.Suppressed = suppressed
}

// WithUUID adds the uuid to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) WithUUID(uuid string) *GetVulnerabilitiesByProjectParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the get vulnerabilities by project params
func (o *GetVulnerabilitiesByProjectParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *GetVulnerabilitiesByProjectParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Suppressed != nil {

		// query param suppressed
		var qrSuppressed bool

		if o.Suppressed != nil {
			qrSuppressed = *o.Suppressed
		}
		qSuppressed := swag.FormatBool(qrSuppressed)
		if qSuppressed != "" {

			if err := r.SetQueryParam("suppressed", qSuppressed); err != nil {
				return err
			}
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
